=== requirements.txt ===
jonathonl/shrinkwrap@v1.2.0
