=== debian/changelog ===
savvy (2.1.0-4) unstable; urgency=medium

  * Fix build with CMake 4
    Closes: #1113483
  * d/watch: version=5
  * Standards-Version: 4.7.2 (routine-update)
  * debputy lint --auto-fix (routine-update)

 -- Andreas Tille <tille@debian.org>  Mon, 20 Oct 2025 13:33:55 +0200

savvy (2.1.0-3) unstable; urgency=medium

  * gcc-14.patch: new: fix an improper assignment in an assert.
    (Closes: #1075487)
  * d/control: add myself to uploaders.
  * d/control: declare compliance to standards version 4.7.0.

 -- Étienne Mollier <emollier@debian.org>  Tue, 06 Aug 2024 20:55:26 +0200

savvy (2.1.0-2) unstable; urgency=medium

  [ Nilesh Patra ]
  * Add patch to fix i386 build

  [ Andreas Tille ]
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Wed, 26 Oct 2022 20:44:23 +0200

savvy (2.1.0-1) unstable; urgency=medium

  * Initial release (Closes: #1021788)

 -- Andreas Tille <tille@debian.org>  Fri, 14 Oct 2022 21:19:28 +0200
