=== debian/control ===
Source: savvy
Standards-Version: 4.7.2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders:
 Andreas Tille <tille@debian.org>,
 Étienne Mollier <emollier@debian.org>,
Section: science
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libshrinkwrap-dev,
 libzstd-dev,
 zlib1g-dev,
Vcs-Browser: https://salsa.debian.org/med-team/savvy
Vcs-Git: https://salsa.debian.org/med-team/savvy.git
Homepage: https://github.com/statgen/savvy
Rules-Requires-Root: no

Package: savvy-util
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: conversion tool for SAV file format
 Savvy is the official C++ interface for the SAV file format and offers
 seamless support for BCF and VCF files.
 .
 The binary sav can be used to handle SAV filed.

Package: libsavvy-dev
Architecture: all
Section: libdevel
Depends:
 ${misc:Depends},
 libshrinkwrap-dev,
Description: C++ interface for the SAV file format
 Savvy is the official C++ interface for the SAV file format and offers
 seamless support for BCF and VCF files.
 .
 This package contains the header files for development.
