=== debian/watch ===
Version: 5

Template: Github
Owner: statgen
Project: savvy
